<template>
    <!-- Choose Plan -->
    <div class="choose-plan-screen dialog-wrapper">
        <transition appear name="slide">
            <div class="transition-wrapper" key="wrapper">
                <div class="type_plan" v-if="!isGo" key="main_screen">
                    <h3>CHOOSE PLAN TYPE</h3>
                    <div class="plan-wrapper">
                        <div class="plan-item text-center" @click="isGo = !isGo; getPlans('monthly')">
                            <h2>Monthly</h2>
                            <p class="plan-description">
                            </p>
                        </div>
                    </div>
                </div>
                <div v-if="isGo" class="type_paygo">
                    <h3>CHOOSE PLAN</h3>
                    <div class="plan-wrapper">
                        <div class="select-price">
                            <custom-preloader class="light" v-if="loading"></custom-preloader>
                            <div v-for="(plan, key) in plans" :key="key" class="plan-price" @click="selectPlan(plan)" :class="{ active: plan.id === selectedPlan.id }">
                                <h2 class="price">${{ plan.planPrice }}</h2>
                                <p>
                                    <span>{{ plan.name }}</span>
                                </p>
                            </div>
                        </div>
                        <div class="total-info text-center">
                            <h4>TOTAL MONTHLY PRICE</h4>
                            <h2 class="price">${{ selectedPlan.planPrice || '0' }}</h2>
                            <div class="total-info-choosen">
                                {{ selectedPlan.descriptions || '-' }}
                            </div>
                            <div class="total-info-include">
                                {{ selectedPlan.options }}
                            </div>
                        </div>
                        <div class="button_set">
                            <button @click="showDone" class="btn btn-main active">Connect Plan</button>
                        </div>
                    </div>
                </div>
            </div>
        </transition>
    </div>
</template>

<script>
    import Client from '../../../../modules/http-custom';

    export default {
        props: ['go'],
        data() {
            return {
                isGo: this.go || false,
                plans: [],
                selectedPlan: { id: undefined },
                loading: false,
            }
        },
        mounted() {
            this.isGo = true;
            this.getPlans('monthly');
        },
        watch: {
            loading: function (old, value) {
                this.$root.eventHub.$emit('welcomeLoadingChanged', value);
            },
            selectedPlan: function () {
                this.$root.eventHub.$emit('selectedPlanChanged', this.selectedPlan);
            },
        },
        methods: {
            getPlans (type) {
                this.loading = true;
                Client.call(`network/${this.$root.rootUserNetwork}/plan`, { type: type })
                    .then(response => {
                            if (response.data.status) {
                                this.plans = Array.isArray(response.data.data) ? response.data.data : Object.values(response.data.data);
                                this.loading = false;
                            } else {
                                this.plans = [];
                                throw new Error(response.data.message);
                            }
                        })
                    .catch(error => {
                        this.errorHandler(error);
                        this.loading = false;
                    })
            },

            selectPlan(plan) {
                this.selectedPlan = {
                    ...plan
                };
            },

            planReset() {
                this.plans = [];
                this.selectedPlan = { id: undefined };
            },
        },
        inject: ['showDone', 'errorHandler']
    }
</script>
